<!DOCTYPE html><html lang="en"><head><meta charset="utf-8"><meta name="viewport" content="width=device-width, initial-scale=1.0"><meta name="generator" content="rustdoc"><meta name="description" content="Source of the Rust file `/nix/store/kaan79bbbx80h17lcc5ay919l5r6bqlz-vendored-sources/getrandom-0.2.7/src/use_file.rs`."><meta name="keywords" content="rust, rustlang, rust-lang"><title>use_file.rs - source</title><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceSerif4-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../FiraSans-Regular.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../FiraSans-Medium.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceCodePro-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceSerif4-Bold.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceCodePro-Semibold.ttf.woff2"><link rel="stylesheet" type="text/css" href="../../normalize.css"><link rel="stylesheet" type="text/css" href="../../rustdoc.css" id="mainThemeStyle"><link rel="stylesheet" type="text/css" href="../../ayu.css" disabled><link rel="stylesheet" type="text/css" href="../../dark.css" disabled><link rel="stylesheet" type="text/css" href="../../light.css" id="themeStyle"><script id="default-settings" ></script><script src="../../storage.js"></script><script defer src="../../source-script.js"></script><script defer src="../../source-files.js"></script><script defer src="../../main.js"></script><noscript><link rel="stylesheet" href="../../noscript.css"></noscript><link rel="icon" href="https://www.rust-lang.org/favicon.ico"></head><body class="rustdoc source"><!--[if lte IE 11]><div class="warning">This old browser is unsupported and will most likely display funky things.</div><![endif]--><nav class="mobile-topbar"><button class="sidebar-menu-toggle">&#9776;</button><a class="sidebar-logo" href="../../getrandom/index.html"><div class="logo-container"><img src="https://www.rust-lang.org/logos/rust-logo-128x128-blk.png" alt="logo"></div>
        </a><h2 class="location"></h2>
    </nav>
    <nav class="sidebar"><a class="sidebar-logo" href="../../getrandom/index.html"><div class="logo-container">
                    <img src="https://www.rust-lang.org/logos/rust-logo-128x128-blk.png" alt="logo"></div>
        </a></nav><main><div class="width-limiter"><div class="sub-container"><a class="sub-logo-container" href="../../getrandom/index.html">
                        <img src="https://www.rust-lang.org/logos/rust-logo-128x128-blk.png" alt="logo"></a><nav class="sub"><form class="search-form"><div class="search-container"><span></span><input class="search-input" name="search" autocomplete="off" spellcheck="false" placeholder="Click or press ‘S’ to search, ‘?’ for more options…" type="search"><div id="help-button" title="help" tabindex="-1"><button type="button">?</button></div><div id="settings-menu" tabindex="-1">
                                <a href="../../settings.html" title="settings"><img width="22" height="22" alt="Change settings" src="../../wheel.svg"></a></div>
                        </div></form></nav></div><section id="main-content" class="content"><div class="example-wrap"><pre class="line-numbers"><span id="1">1</span>
<span id="2">2</span>
<span id="3">3</span>
<span id="4">4</span>
<span id="5">5</span>
<span id="6">6</span>
<span id="7">7</span>
<span id="8">8</span>
<span id="9">9</span>
<span id="10">10</span>
<span id="11">11</span>
<span id="12">12</span>
<span id="13">13</span>
<span id="14">14</span>
<span id="15">15</span>
<span id="16">16</span>
<span id="17">17</span>
<span id="18">18</span>
<span id="19">19</span>
<span id="20">20</span>
<span id="21">21</span>
<span id="22">22</span>
<span id="23">23</span>
<span id="24">24</span>
<span id="25">25</span>
<span id="26">26</span>
<span id="27">27</span>
<span id="28">28</span>
<span id="29">29</span>
<span id="30">30</span>
<span id="31">31</span>
<span id="32">32</span>
<span id="33">33</span>
<span id="34">34</span>
<span id="35">35</span>
<span id="36">36</span>
<span id="37">37</span>
<span id="38">38</span>
<span id="39">39</span>
<span id="40">40</span>
<span id="41">41</span>
<span id="42">42</span>
<span id="43">43</span>
<span id="44">44</span>
<span id="45">45</span>
<span id="46">46</span>
<span id="47">47</span>
<span id="48">48</span>
<span id="49">49</span>
<span id="50">50</span>
<span id="51">51</span>
<span id="52">52</span>
<span id="53">53</span>
<span id="54">54</span>
<span id="55">55</span>
<span id="56">56</span>
<span id="57">57</span>
<span id="58">58</span>
<span id="59">59</span>
<span id="60">60</span>
<span id="61">61</span>
<span id="62">62</span>
<span id="63">63</span>
<span id="64">64</span>
<span id="65">65</span>
<span id="66">66</span>
<span id="67">67</span>
<span id="68">68</span>
<span id="69">69</span>
<span id="70">70</span>
<span id="71">71</span>
<span id="72">72</span>
<span id="73">73</span>
<span id="74">74</span>
<span id="75">75</span>
<span id="76">76</span>
<span id="77">77</span>
<span id="78">78</span>
<span id="79">79</span>
<span id="80">80</span>
<span id="81">81</span>
<span id="82">82</span>
<span id="83">83</span>
<span id="84">84</span>
<span id="85">85</span>
<span id="86">86</span>
<span id="87">87</span>
<span id="88">88</span>
<span id="89">89</span>
<span id="90">90</span>
<span id="91">91</span>
<span id="92">92</span>
<span id="93">93</span>
<span id="94">94</span>
<span id="95">95</span>
<span id="96">96</span>
<span id="97">97</span>
<span id="98">98</span>
<span id="99">99</span>
<span id="100">100</span>
<span id="101">101</span>
<span id="102">102</span>
<span id="103">103</span>
<span id="104">104</span>
<span id="105">105</span>
<span id="106">106</span>
<span id="107">107</span>
<span id="108">108</span>
<span id="109">109</span>
<span id="110">110</span>
<span id="111">111</span>
<span id="112">112</span>
<span id="113">113</span>
<span id="114">114</span>
<span id="115">115</span>
<span id="116">116</span>
<span id="117">117</span>
<span id="118">118</span>
<span id="119">119</span>
<span id="120">120</span>
<span id="121">121</span>
<span id="122">122</span>
<span id="123">123</span>
<span id="124">124</span>
<span id="125">125</span>
<span id="126">126</span>
<span id="127">127</span>
<span id="128">128</span>
<span id="129">129</span>
<span id="130">130</span>
<span id="131">131</span>
<span id="132">132</span>
<span id="133">133</span>
<span id="134">134</span>
<span id="135">135</span>
<span id="136">136</span>
<span id="137">137</span>
<span id="138">138</span>
<span id="139">139</span>
</pre><pre class="rust"><code><span class="comment">// Copyright 2018 Developers of the Rand project.</span>
<span class="comment">//</span>
<span class="comment">// Licensed under the Apache License, Version 2.0 &lt;LICENSE-APACHE or</span>
<span class="comment">// https://www.apache.org/licenses/LICENSE-2.0&gt; or the MIT license</span>
<span class="comment">// &lt;LICENSE-MIT or https://opensource.org/licenses/MIT&gt;, at your</span>
<span class="comment">// option. This file may not be copied, modified, or distributed</span>
<span class="comment">// except according to those terms.</span>

<span class="doccomment">//! Implementations that just need to read from a file</span>
<span class="kw">use</span> <span class="kw">crate</span>::{
    <span class="ident">util::LazyUsize</span>,
    <span class="ident">util_libc</span>::{<span class="ident">open_readonly</span>, <span class="ident">sys_fill_exact</span>},
    <span class="ident">Error</span>,
};
<span class="kw">use</span> <span class="ident">core</span>::{
    <span class="ident">cell::UnsafeCell</span>,
    <span class="ident">sync::atomic</span>::{<span class="ident">AtomicUsize</span>, <span class="ident">Ordering::Relaxed</span>},
};

<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">any</span>(
    <span class="ident">target_os</span> <span class="op">=</span> <span class="string">&quot;dragonfly&quot;</span>,
    <span class="ident">target_os</span> <span class="op">=</span> <span class="string">&quot;emscripten&quot;</span>,
    <span class="ident">target_os</span> <span class="op">=</span> <span class="string">&quot;haiku&quot;</span>,
    <span class="ident">target_os</span> <span class="op">=</span> <span class="string">&quot;macos&quot;</span>,
    <span class="ident">target_os</span> <span class="op">=</span> <span class="string">&quot;solaris&quot;</span>,
    <span class="ident">target_os</span> <span class="op">=</span> <span class="string">&quot;illumos&quot;</span>
))]</span>
<span class="kw">const</span> <span class="ident">FILE_PATH</span>: <span class="kw-2">&amp;</span><span class="ident">str</span> <span class="op">=</span> <span class="string">&quot;/dev/random\0&quot;</span>;
<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">any</span>(<span class="ident">target_os</span> <span class="op">=</span> <span class="string">&quot;android&quot;</span>, <span class="ident">target_os</span> <span class="op">=</span> <span class="string">&quot;linux&quot;</span>, <span class="ident">target_os</span> <span class="op">=</span> <span class="string">&quot;redox&quot;</span>))]</span>
<span class="kw">const</span> <span class="ident">FILE_PATH</span>: <span class="kw-2">&amp;</span><span class="ident">str</span> <span class="op">=</span> <span class="string">&quot;/dev/urandom\0&quot;</span>;

<span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">getrandom_inner</span>(<span class="ident">dest</span>: <span class="kw-2">&amp;mut</span> [<span class="ident">u8</span>]) -&gt; <span class="prelude-ty">Result</span><span class="op">&lt;</span>(), <span class="ident">Error</span><span class="op">&gt;</span> {
    <span class="kw">let</span> <span class="ident">fd</span> <span class="op">=</span> <span class="ident">get_rng_fd</span>()<span class="question-mark">?</span>;
    <span class="kw">let</span> <span class="ident">read</span> <span class="op">=</span> <span class="op">|</span><span class="ident">buf</span>: <span class="kw-2">&amp;mut</span> [<span class="ident">u8</span>]<span class="op">|</span> <span class="kw">unsafe</span> { <span class="ident">libc::read</span>(<span class="ident">fd</span>, <span class="ident">buf</span>.<span class="ident">as_mut_ptr</span>() <span class="kw">as</span> <span class="kw-2">*mut</span> <span class="kw">_</span>, <span class="ident">buf</span>.<span class="ident">len</span>()) };

    <span class="kw">if</span> <span class="macro">cfg!</span>(<span class="ident">target_os</span> <span class="op">=</span> <span class="string">&quot;emscripten&quot;</span>) {
        <span class="comment">// `Crypto.getRandomValues` documents `dest` should be at most 65536 bytes.</span>
        <span class="kw">for</span> <span class="ident">chunk</span> <span class="kw">in</span> <span class="ident">dest</span>.<span class="ident">chunks_mut</span>(<span class="number">65536</span>) {
            <span class="ident">sys_fill_exact</span>(<span class="ident">chunk</span>, <span class="ident">read</span>)<span class="question-mark">?</span>;
        }
    } <span class="kw">else</span> {
        <span class="ident">sys_fill_exact</span>(<span class="ident">dest</span>, <span class="ident">read</span>)<span class="question-mark">?</span>;
    }
    <span class="prelude-val">Ok</span>(())
}

<span class="comment">// Returns the file descriptor for the device file used to retrieve random</span>
<span class="comment">// bytes. The file will be opened exactly once. All subsequent calls will</span>
<span class="comment">// return the same file descriptor. This file descriptor is never closed.</span>
<span class="kw">fn</span> <span class="ident">get_rng_fd</span>() -&gt; <span class="prelude-ty">Result</span><span class="op">&lt;</span><span class="ident">libc::c_int</span>, <span class="ident">Error</span><span class="op">&gt;</span> {
    <span class="kw">static</span> <span class="ident">FD</span>: <span class="ident">AtomicUsize</span> <span class="op">=</span> <span class="ident">AtomicUsize::new</span>(<span class="ident">LazyUsize::UNINIT</span>);
    <span class="kw">fn</span> <span class="ident">get_fd</span>() -&gt; <span class="prelude-ty">Option</span><span class="op">&lt;</span><span class="ident">libc::c_int</span><span class="op">&gt;</span> {
        <span class="kw">match</span> <span class="ident">FD</span>.<span class="ident">load</span>(<span class="ident">Relaxed</span>) {
            <span class="ident">LazyUsize::UNINIT</span> =&gt; <span class="prelude-val">None</span>,
            <span class="ident">val</span> =&gt; <span class="prelude-val">Some</span>(<span class="ident">val</span> <span class="kw">as</span> <span class="ident">libc::c_int</span>),
        }
    }

    <span class="comment">// Use double-checked locking to avoid acquiring the lock if possible.</span>
    <span class="kw">if</span> <span class="kw">let</span> <span class="prelude-val">Some</span>(<span class="ident">fd</span>) <span class="op">=</span> <span class="ident">get_fd</span>() {
        <span class="kw">return</span> <span class="prelude-val">Ok</span>(<span class="ident">fd</span>);
    }

    <span class="comment">// SAFETY: We use the mutex only in this method, and we always unlock it</span>
    <span class="comment">// before returning, making sure we don&#39;t violate the pthread_mutex_t API.</span>
    <span class="kw">static</span> <span class="ident">MUTEX</span>: <span class="ident">Mutex</span> <span class="op">=</span> <span class="ident">Mutex::new</span>();
    <span class="kw">unsafe</span> { <span class="ident">MUTEX</span>.<span class="ident">lock</span>() };
    <span class="kw">let</span> <span class="ident">_guard</span> <span class="op">=</span> <span class="ident">DropGuard</span>(<span class="op">|</span><span class="op">|</span> <span class="kw">unsafe</span> { <span class="ident">MUTEX</span>.<span class="ident">unlock</span>() });

    <span class="kw">if</span> <span class="kw">let</span> <span class="prelude-val">Some</span>(<span class="ident">fd</span>) <span class="op">=</span> <span class="ident">get_fd</span>() {
        <span class="kw">return</span> <span class="prelude-val">Ok</span>(<span class="ident">fd</span>);
    }

    <span class="comment">// On Linux, /dev/urandom might return insecure values.</span>
    <span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">any</span>(<span class="ident">target_os</span> <span class="op">=</span> <span class="string">&quot;android&quot;</span>, <span class="ident">target_os</span> <span class="op">=</span> <span class="string">&quot;linux&quot;</span>))]</span>
    <span class="ident">wait_until_rng_ready</span>()<span class="question-mark">?</span>;

    <span class="kw">let</span> <span class="ident">fd</span> <span class="op">=</span> <span class="kw">unsafe</span> { <span class="ident">open_readonly</span>(<span class="ident">FILE_PATH</span>)<span class="question-mark">?</span> };
    <span class="comment">// The fd always fits in a usize without conflicting with UNINIT.</span>
    <span class="macro">debug_assert!</span>(<span class="ident">fd</span> <span class="op">&gt;</span><span class="op">=</span> <span class="number">0</span> <span class="op">&amp;&amp;</span> (<span class="ident">fd</span> <span class="kw">as</span> <span class="ident">usize</span>) <span class="op">&lt;</span> <span class="ident">LazyUsize::UNINIT</span>);
    <span class="ident">FD</span>.<span class="ident">store</span>(<span class="ident">fd</span> <span class="kw">as</span> <span class="ident">usize</span>, <span class="ident">Relaxed</span>);

    <span class="prelude-val">Ok</span>(<span class="ident">fd</span>)
}

<span class="comment">// Succeeds once /dev/urandom is safe to read from</span>
<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">any</span>(<span class="ident">target_os</span> <span class="op">=</span> <span class="string">&quot;android&quot;</span>, <span class="ident">target_os</span> <span class="op">=</span> <span class="string">&quot;linux&quot;</span>))]</span>
<span class="kw">fn</span> <span class="ident">wait_until_rng_ready</span>() -&gt; <span class="prelude-ty">Result</span><span class="op">&lt;</span>(), <span class="ident">Error</span><span class="op">&gt;</span> {
    <span class="comment">// Poll /dev/random to make sure it is ok to read from /dev/urandom.</span>
    <span class="kw">let</span> <span class="ident">fd</span> <span class="op">=</span> <span class="kw">unsafe</span> { <span class="ident">open_readonly</span>(<span class="string">&quot;/dev/random\0&quot;</span>)<span class="question-mark">?</span> };
    <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">pfd</span> <span class="op">=</span> <span class="ident">libc::pollfd</span> {
        <span class="ident">fd</span>,
        <span class="ident">events</span>: <span class="ident">libc::POLLIN</span>,
        <span class="ident">revents</span>: <span class="number">0</span>,
    };
    <span class="kw">let</span> <span class="ident">_guard</span> <span class="op">=</span> <span class="ident">DropGuard</span>(<span class="op">|</span><span class="op">|</span> <span class="kw">unsafe</span> {
        <span class="ident">libc::close</span>(<span class="ident">fd</span>);
    });

    <span class="kw">loop</span> {
        <span class="comment">// A negative timeout means an infinite timeout.</span>
        <span class="kw">let</span> <span class="ident">res</span> <span class="op">=</span> <span class="kw">unsafe</span> { <span class="ident">libc::poll</span>(<span class="kw-2">&amp;mut</span> <span class="ident">pfd</span>, <span class="number">1</span>, <span class="op">-</span><span class="number">1</span>) };
        <span class="kw">if</span> <span class="ident">res</span> <span class="op">&gt;</span><span class="op">=</span> <span class="number">0</span> {
            <span class="macro">debug_assert_eq!</span>(<span class="ident">res</span>, <span class="number">1</span>); <span class="comment">// We only used one fd, and cannot timeout.</span>
            <span class="kw">return</span> <span class="prelude-val">Ok</span>(());
        }
        <span class="kw">let</span> <span class="ident">err</span> <span class="op">=</span> <span class="ident"><span class="kw">crate</span>::util_libc::last_os_error</span>();
        <span class="kw">match</span> <span class="ident">err</span>.<span class="ident">raw_os_error</span>() {
            <span class="prelude-val">Some</span>(<span class="ident">libc::EINTR</span>) <span class="op">|</span> <span class="prelude-val">Some</span>(<span class="ident">libc::EAGAIN</span>) =&gt; <span class="kw">continue</span>,
            <span class="kw">_</span> =&gt; <span class="kw">return</span> <span class="prelude-val">Err</span>(<span class="ident">err</span>),
        }
    }
}

<span class="kw">struct</span> <span class="ident">Mutex</span>(<span class="ident">UnsafeCell</span><span class="op">&lt;</span><span class="ident">libc::pthread_mutex_t</span><span class="op">&gt;</span>);

<span class="kw">impl</span> <span class="ident">Mutex</span> {
    <span class="kw">const</span> <span class="kw">fn</span> <span class="ident">new</span>() -&gt; <span class="self">Self</span> {
        <span class="self">Self</span>(<span class="ident">UnsafeCell::new</span>(<span class="ident">libc::PTHREAD_MUTEX_INITIALIZER</span>))
    }
    <span class="kw">unsafe</span> <span class="kw">fn</span> <span class="ident">lock</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) {
        <span class="kw">let</span> <span class="ident">r</span> <span class="op">=</span> <span class="ident">libc::pthread_mutex_lock</span>(<span class="self">self</span>.<span class="number">0</span>.<span class="ident">get</span>());
        <span class="macro">debug_assert_eq!</span>(<span class="ident">r</span>, <span class="number">0</span>);
    }
    <span class="kw">unsafe</span> <span class="kw">fn</span> <span class="ident">unlock</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) {
        <span class="kw">let</span> <span class="ident">r</span> <span class="op">=</span> <span class="ident">libc::pthread_mutex_unlock</span>(<span class="self">self</span>.<span class="number">0</span>.<span class="ident">get</span>());
        <span class="macro">debug_assert_eq!</span>(<span class="ident">r</span>, <span class="number">0</span>);
    }
}

<span class="kw">unsafe</span> <span class="kw">impl</span> <span class="ident">Sync</span> <span class="kw">for</span> <span class="ident">Mutex</span> {}

<span class="kw">struct</span> <span class="ident">DropGuard</span><span class="op">&lt;</span><span class="ident">F</span>: <span class="ident">FnMut</span>()<span class="op">&gt;</span>(<span class="ident">F</span>);

<span class="kw">impl</span><span class="op">&lt;</span><span class="ident">F</span>: <span class="ident">FnMut</span>()<span class="op">&gt;</span> <span class="ident">Drop</span> <span class="kw">for</span> <span class="ident">DropGuard</span><span class="op">&lt;</span><span class="ident">F</span><span class="op">&gt;</span> {
    <span class="kw">fn</span> <span class="ident">drop</span>(<span class="kw-2">&amp;mut</span> <span class="self">self</span>) {
        <span class="self">self</span>.<span class="number">0</span>()
    }
}
</code></pre></div>
</section></div></main><div id="rustdoc-vars" data-root-path="../../" data-current-crate="getrandom" data-themes="ayu,dark,light" data-resource-suffix="" data-rustdoc-version="1.64.0-dev" ></div>
</body></html>